#include   <sys/types.h>
#include   <sys/wait.h>
#include   <stdio.h>
#include   <stdlib.h>
#include   <unistd.h>
#include   <errno.h>

char   *env_init[] = { "USER=unknown", "PATH=/tmp", NULL };

int main()
{
   pid_t   pid;

   if ( (pid = fork()) < 0) {
      fprintf(stderr,"fork error");
           exit(-1);
   }
   else if (pid == 0) {   /* specify filename, inherit environment */
      printf("\n\n\nexeclp('./echoall\', ..., NULL)\n");
      if (execlp("./echoall",
               "echoall", "only 1 arg", (char *) 0) < 0){
         fprintf(stderr,"execle error\n");
         exit(-5);
      }
   }
   if (waitpid(pid, NULL, 0) < 0) {
      fprintf(stderr,"wait error\n");
      exit(-2);
   }
   if ( (pid = fork()) < 0) {
      fprintf(stderr,"fork error\n");
      exit(-3);
   }
   else if (pid == 0) {   /* specify pathname, specify environment */
      printf("\n\n\nexecle('./echoall','-echoall', ....,NULL)\n");
      if (execle("./echoall",
               "-echoall", "myarg1", "MY ARG2", (char *) 0,
               env_init) < 0) {
         fprintf(stderr,"execlp error\n");
         exit(-4);
      }
   }
   if (waitpid(pid, NULL, 0) < 0) {
      fprintf(stderr,"wait error");
      exit(-2);
   }
   exit(0);
}
